import { gpxReceiver } from './gpx-receiver';
import { invitationReceiver } from './invitation-receiver';

const receivers = {
  invitationReceiver,
  gpxReceiver,
};

export const receiveIntent = (intent: any) => {
  let url: URL | undefined;
  try {
    url = new URL(
      intent.extras && intent.extras['android.intent.extra.STREAM']
        ? intent.extras['android.intent.extra.STREAM']
        : intent.data
    );
  } catch (error) {
    console.error({ caller: 'receiveIntent / URL', error });
  }

  const found = Object.values(receivers).some((receiver) =>
    receiver(intent, url)
  );

  return found;
};
